unit hiGlobalVarEx;

interface

uses Kol,Share,Debug,hiGlobalVar;

type
  PPHI_EventEx = ^PHI_EventEx;
  PHI_EventEx = ^THI_EventEx;
  THI_EventEx = record
    Event:THI_Event;
    Next:PHI_EventEx;
  end;

  THIGlobalVarEx = class(THIGlobalVar)
   protected
    Name:string;
    Gev:THI_EventEx;
    Last:boolean;
    procedure SetData(Data:TData);override;
    procedure SetName(const Value:string);override;
    procedure SetNType(t:byte);
    procedure RemoveEvent;
   public
    _prop_SkipOwn:boolean;
    destructor Destroy; override;
    procedure _work_doNotifyType(var _Data:TData; Index:word);
    property _event_onValue:THI_Event write Gev.Event;
    property _prop_NotifyType:byte write SetNType;
  end;

implementation

destructor THIGlobalVarEx.Destroy;
begin
  RemoveEvent;
  inherited;
end;

procedure THIGlobalVarEx.RemoveEvent;
var P:PPHI_EventEx;
begin
  if GData = nil then exit;
  P := PPHI_EventEx(@GData.Next);
  while P^ <> nil do begin
    if P^ = @Gev then begin
      P^ := Gev.Next;
      exit;
    end;
    P := @(P^.Next);
  end;
end;

procedure THIGlobalVarEx.SetName;
var P:PPHI_EventEx;
begin
  if GData <> nil then RemoveEvent;                                         
  Name := Value;
  GData := ForceGVar(Value);
  if GData = nil then exit; 
  P := PPHI_EventEx(@GData.Next);
  if Last then while P^ <> nil do P := @(P^.Next);
  Gev.Next := P^;
  P^ := @Gev.Event;
end;

procedure THIGlobalVarEx._work_doNotifyType;
begin
  SetNType(ToInteger(_Data));
end;

procedure THIGlobalVarEx.SetNType;
begin
  Last := t>0; 
  SetName(Name);
end;

procedure THIGlobalVarEx.SetData;
var P:PHI_Event;
begin
  if GData = nil then exit; 
  P := GData.Next;
  dtData(GData^,Data);
  GData.Next := P; 
  while P <> nil do begin
    if (not _prop_SkipOwn)or(P <> @Gev.Event) then 
      _hi_onEvent_(P^,Data);
    P := PHI_Event(PHI_EventEx(P).Next);
  end;
end;

end.
